package NestedClasses;

import java.util.ArrayList;
import java.util.List;

public class House {
	private String address;
	private List<Room> rooms;
	private double  height;

	public class Room {
		private double width;
    	private double height;
    	
    	public Room(double height, double width) {
			this.height = height;
			this.width = width;
		}

		// implicit reference to a House
    	public String toString(){
    		return  "Room height: " + this.height + " House height: " + House.this.height + "address is: " + House.this.address;
    	}
    	
    	public House getHouse() {
    		return House.this;
    	}
	}
	
	public House(String  add){
		address = add;
		rooms = new ArrayList<Room>();
	}
	
	public void addRoom(double height, double width){
		Room room = new Room(height, width);
		rooms.add(room);
	}

	public Room getRoom(int i){
	   return rooms.get(i);
	}
	
	public String toString(){
		return  "Address of the house is: " + House.this.address + "\tNumber of rooms in house:" + rooms.size();
	}
	
	public static void main(String [] args) {

		House house = new House("Hashlom 6");
	  	house.addRoom(3.8, 1.5); 

	  	Room r = house.getRoom(0);
	  	System.out.println(r.toString());
	  	
	  	// compilation error for new Room - example from class
	  	//Room room = new Room(1.5,3.8);

	  	Room room1 = new House("Hashalom 7").new Room(1.3, 2.1);
	  	System.out.println(room1.toString());
	  	System.out.println(house.height);
	  	System.out.println(house.getRoom(0).width);
	  	
	  	House house2 = room1.getHouse();
	  	System.out.println(house2);
	  	
	  	House.Room room2 = house2.new Room(2.3, 4.2);
	  	System.out.println(room2.toString());
	}

}
